#include <stdio.h>
#include <stdlib.h>

int d[200000];
int u[200000];

int veceodx(int n,int a[],int x){
    int l=-1,d=n-1,s;

    while(l<d){
        s=l/2+d/2;
        if(a[s]<x){
            d=s-1;
        }
        else{
            l=s;
        }
    }
    return d;
}

int manjeodx(int n,int a[],int x){
    int l=-1,d=n-1,s;

    while(l<d){
        s=l/2+d/2;
        if(a[s]>x){
            d=s-1;
        }
        else{
            l=s;
        }
    }
    return l;
}

int main()
{
    int n,m,l,r,x,br,p;
    scanf("%d%d",&n,&m);
    int dmin[200000];
    int umax[200000];
    for(int i=0;i<n;i++){
        scanf("%d%d",&d[i],&u[i]);
    }
    if(n<=1000 && m<=1000){
        for(int i=0;i<m;i++){
            scanf("%d%d%d",&l,&r,&x);
            br=0;
            l--;
            r--;
            for(int j=l;j<=r;j++){
                if(d[j]<=x && u[j]>=x){
                    br++;
                }
            }
            printf("%d\n",br);
        }
    }
    else{
        dmin[0]=d[0];
        for(int i=1;i<n;i++){
            if(dmin[i-1]>d[i]){
                dmin[i]=d[i];
            }
            else{
                dmin[i]=dmin[i-1];
            }
        }
        umax[n-1]=u[n-1];
        for(int i=n-2;i>=0;i--){
            if(umax[i+1]<u[i]){
                umax[i]=u[i];
            }
            else{
                umax[i]=umax[i-1];
            }
        }
        for(int i=0;i<m;i++){
            scanf("%d%d%d",&l,&r,&x);
            br=0;
            l--;
            r--;
            p=veceodx(n,umax,x);
            if(p==-1 || p<l){
                printf("0");
            }
            else{
                if(r>p){
                    r=p;
                }
                p=manjeodx(n,dmin,x);
                if(p==-1 || p>r){
                    printf("0\n");
                }
                else{
                    if(l<p){
                        l=p;
                    }
                    for(int j=l;j<=r;j++){
                        if(d[j]<=x && u[j]>=x){
                            br++;
                        }
                    }
                    printf("%d\n",br);
                }
            }
        }
    }
    return 0;
}